=== debian/changelog ===
openclonk (8.0-2) unstable; urgency=medium

  * Use the Games team's Alioth list as the maintainer.
  * Disable the editor on arm. (Closes: #890264)

 -- Philipp Kern <pkern@debian.org>  Thu, 15 Feb 2018 22:58:32 +0100

openclonk (8.0-1) unstable; urgency=medium

  * New upstream version.
    - Remove Debian-specific patches: applied upstream.
    - Updated build dependencies to pull in qt5 for the editor.
    - Disable format string hardening to avoid a build failure on
      a custom printf wrapper.
  * Update Debian packaging:
    - Put the package under the Games team's umbrella.
    - Update VCS location to Salsa.
    - Let watch file point to Github.
    - Drop the explicit debug package.
    - Drop the Debian menu file, as a .desktop file is shipped.
    - Bump debhelper compat level to 10 for parallel building by default.

 -- Philipp Kern <pkern@debian.org>  Sun, 11 Feb 2018 17:01:35 +0100

openclonk (7.0-5) unstable; urgency=medium

  * Do not build-depend on OpenSSL, it is no longer needed.
    (Closes: #854868)
  * Honor SOURCE_DATE_EPOCH in the environment for the copyright
    year to make the build reproducible, thanks to Alexis Bienvenüe.
    (Closes: #823797)

 -- Philipp Kern <pkern@debian.org>  Thu, 29 Jun 2017 22:27:06 +0200
