=== debian/control ===
Source: openclonk
Section: games
Priority: optional
Maintainer: Debian Games Packaging Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Philipp Kern <pkern@debian.org>
Build-Depends: debhelper (>= 10), cmake (>= 3.0.2), libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev (>= 1.5.6), libgl1-mesa-dev, libpng-dev, libsdl2-dev, libsdl2-mixer-dev, libgtk-3-dev, qtbase5-dev, libjpeg-dev, zlib1g-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick, libtinyxml-dev, libopenal-dev, libalut-dev, libgtest-dev
Standards-Version: 4.1.3
Homepage: http://www.openclonk.org
VCS-Git: https://salsa.debian.org/games-team/openclonk.git
VCS-Browser: https://salsa.debian.org/games-team/openclonk

Package: openclonk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openclonk-data (= ${source:Version})
Description: multiplayer game of strategy, action and skill
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the OpenClonk engine.

Package: openclonk-data
Architecture: all
Depends: ${misc:Depends}
Recommends: openclonk
Description: multiplayer game of strategy, action and skill - data
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the game data.
