=== thirdparty/getopt/CMakeLists.txt ===
add_library(getopt
	getopt.c
	getopt.h
	getopt_long.c
)
