=== tools/install_mac/Makefile ===

# Project data
NAME = OpenClonk
VERSION = 2.0

# Assume default XCode output directory
SOURCE_DIR = ../../Release
SOURCE_FILES = openclonk.app

TEMPLATE_DMG = template.dmg

include fancy-dmg/Makefile
