=== debian/changelog ===
openclonk (8.1-5) unstable; urgency=medium

  * QA upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1113354)
  * Backport upstream fix for FTBFS with miniupnpc 2.3.
  * Fix FTBFS with GoogleTest 1.17.0. (Closes: #1114245)
  * Workaround parallel build issue. (Closes: #1104391)

 -- Adrian Bunk <bunk@debian.org>  Tue, 07 Oct 2025 18:30:37 +0300

openclonk (8.1-4) unstable; urgency=medium

  * QA upload.

  [ Georges Khaznadar ]
  * bumped standards: debhelper-compat (=13), Standards-Version: 4.6.2
  * added the path usr/share/appdata/openclonk.appdata.xml to the file
    d/openclonk.install, to please dh_missing, which is triggered by
    debhelper level 13.

  [ Boyuan Yang ]
  * debian/compat: Dropped.
  * debian/patches: Refresh patches with "gbp pq".
  * debian/upstream/metadata: Add Repository and Repository-Browse.
  * debian/control: Update obsolete package dependency:
    libfreetype6-dev => libfreetype-dev, libgl1-mesa-dev => libgl-dev.

 -- Boyuan Yang <byang@debian.org>  Mon, 04 Sep 2023 15:37:46 -0400

openclonk (8.1-3) unstable; urgency=medium

  * QA upload.
  * Fix FTCBFS: Pass -DIMPORT_NATIVE_TOOLS=path-to-native-build.
    Thanks to Helmut Grohne. (Closes: #996841)
  * Fix ftbfs on GCC-11. (Closes: #984274)

 -- Bo YU <tsu.yubo@gmail.com>  Fri, 23 Dec 2022 21:49:46 +0800

openclonk (8.1-2) unstable; urgency=medium

  * Remove myself from Uploaders and orphan the package.
  * Update Debian packaging:
    - Point Homepage to the https version of the site.
    - openclonk-data: Mark as Multi-Arch: foreign
    - Set Rules-Requires-Root: no.

 -- Philipp Kern <pkern@debian.org>  Sun, 03 Jan 2021 22:24:57 +0100

openclonk (8.1-1) unstable; urgency=medium

  * New upstream version.
    - Reenable format string hardening (fixed upstream).
    - Use the system-provided blake2 rather than the vendored copy.

 -- Philipp Kern <pkern@debian.org>  Sun, 18 Mar 2018 14:47:44 +0100
