=== debian/control ===
--- 
+++ 
@@ -1,13 +1,39 @@
 Source: openclonk
 Section: games
 Priority: optional
-Maintainer: Debian Games Packaging Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Philipp Kern <pkern@debian.org>
-Build-Depends: debhelper (>= 10), cmake (>= 3.0.2), libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev (>= 1.5.6), libgl1-mesa-dev, libpng-dev, libsdl2-dev, libsdl2-mixer-dev, libgtk-3-dev, qtbase5-dev, libjpeg-dev, zlib1g-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick, libtinyxml-dev, libopenal-dev, libalut-dev, libgtest-dev
-Standards-Version: 4.1.3
-Homepage: http://www.openclonk.org
-VCS-Git: https://salsa.debian.org/games-team/openclonk.git
-VCS-Browser: https://salsa.debian.org/games-team/openclonk
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Build-Depends: debhelper-compat (= 13),
+ cmake,
+ libx11-dev,
+ libxxf86vm-dev,
+ libxrandr-dev,
+ libxpm-dev,
+ libglew-dev,
+ libgl-dev,
+ libpng-dev,
+ libpng-dev:native,
+ libsdl2-dev,
+ libsdl2-mixer-dev,
+ libgtk-3-dev,
+ qtbase5-dev,
+ libjpeg-dev,
+ libjpeg-dev:native,
+ zlib1g-dev,
+ zlib1g-dev:native,
+ libupnp-dev,
+ libfreetype-dev,
+ libboost-regex-dev,
+ imagemagick,
+ libtinyxml-dev,
+ libopenal-dev,
+ libalut-dev,
+ libgtest-dev,
+ libb2-dev,
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Homepage: https://www.openclonk.org
+Vcs-Git: https://salsa.debian.org/games-team/openclonk.git
+Vcs-Browser: https://salsa.debian.org/games-team/openclonk
 
 Package: openclonk
 Architecture: any
@@ -23,6 +49,7 @@
 
 Package: openclonk-data
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: openclonk
 Description: multiplayer game of strategy, action and skill - data
