=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,5 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
-
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-format
 
 %:
 	dh $@ --buildsystem=cmake -Bbuild
@@ -14,10 +12,20 @@
 endif
 
 override_dh_auto_configure:
+ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+	dpkg-architecture -a$(DEB_BUILD_ARCH) -f -c dh_auto_configure --builddirectory=build-native -- -DHEADLESS_ONLY=ON
+	dpkg-architecture -a$(DEB_BUILD_ARCH) -f -c dh_auto_build --builddirectory=build-native -- c4group
+	dh_auto_configure -- $(CONFIG_ARGS) -DIMPORT_NATIVE_TOOLS=../build-native/NativeToolsExport.cmake
+else
 	dh_auto_configure -- $(CONFIG_ARGS)
+endif
+
+override_dh_auto_build:
+	dh_auto_build --no-parallel -- groups
+	dh_auto_build
 
 override_dh_strip:
 	dh_strip --dbgsym-migration='openclonk-dbg (<< 8.0-1~)'
 
 override_dh_builddeb:
-	dh_builddeb -- -Zxz
+	dh_builddeb
