=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/openclonk-$1\.tar\.gz/ \
  https://github.com/openclonk/openclonk/tags .*/v?(\d\S+)\.tar\.gz
